/*
 * QtObservedMolecule.hpp
 *
 *  Created on: Oct 28, 2015
 *      Author: heber
 */


#ifndef QTOBSERVEDMOLECULE_HPP_
#define QTOBSERVEDMOLECULE_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <QtGui/QWidget>

#include <vector>

#include <boost/any.hpp>

#include "CodePatterns/Observer/Observer.hpp"
#include "CodePatterns/ObservedValue.hpp"

#include "types.hpp"

/** This instance is the ObservedValue representation of a World's molecule.
 *
 * Due to the signal/slot mechanism and its delays, lifetime of objects in the
 * World and their QtGui representation cannot directly be related (without
 * slowing down Actions just for having the representation up to speed).
 * Hence, the required information for displaying and representing these
 * objects must be contained in an extra instance.
 *
 * This is the instance for information about a particular molecule.
 */
class QtObservedMolecule : public QWidget, public Observer
{
  Q_OBJECT

  /** Cstor of QtObservedMolecule.
   *
   * \param _parent Qt parent to automatically destroy when parent is destroyed
   */
  QtObservedMolecule(QWidget * _parent=0);

  /** Dstor of QtObservedMolecule.
   *
   */
  ~QtObservedMolecule();

signals:

private slots:


private:

};


#endif /* QTOBSERVEDMOLECULE_HPP_ */
